define('aim/assignment/view/AddResourcesButtonView',[], function() {
	var AddResourcesButtonView = Backbone.View.extend({
		el: '#naomi-filter-content',
		
		events: {
			"click #add-resource-button" : "handleAddResources",
			"click #remove-resource-button" : "handleRemoveResources",
			"click #add-project-button" : "handleAddProjects",
			"click #remove-project-button" : "handleRemoveProjects",
			"click #checkBoxProjectFilter" : "handleChangeProjectCheckbox",
			"click #checkBoxResourceFilter" : "handleChangeResourceCheckbox"
		},

		initialize : function() {
			this.listenTo(this.model, 'sync', this.render);
		},
			
		render : function() {
			return this;
		},
		
		handleAddResources: function(event) {
			var ids = new Array();
		    AJS.$( "#naomi-resources-multiselect option:selected" ).each(function() {
		        ids.push(this.value);
		      });
			this.model.set('selectedResourceIds',ids);
			this.model.set('operation','addResources');
			this.model.save();
			AJS.$("#findProjects").val("");
			AJS.$("#checkBoxProjectFilter").attr('checked', false);
			AJS.$("#findResources").val("");
			AJS.$("#checkBoxResourceFilter").attr('checked', false);

		},
		
		handleAddProjects: function(event) {
			var ids = new Array();
		    AJS.$( "#naomi-projects-multiselect option:selected" ).each(function() {
		        ids.push(this.value);
		      });
			this.model.set('selectedProjectIds',ids);
			this.model.set('operation','addProjects');
			this.model.save();
			AJS.$("#findProjects").val("");
			AJS.$("#checkBoxProjectFilter").attr('checked', false);
			AJS.$("#findResources").val("");
			AJS.$("#checkBoxResourceFilter").attr('checked', false);

		},
		
		handleRemoveResources: function(event) {
			var ids = new Array();
		    AJS.$( "#naomi-selected-resources-multiselect option:selected" ).each(function() {
		        ids.push(this.value);
		      });
			this.model.set('selectedResourceIds',ids);
			this.model.set('operation','removeResources');
			this.model.save();
			AJS.$("#findProjects").val("");
			AJS.$("#checkBoxProjectFilter").attr('checked', false);
			AJS.$("#findResources").val("");
			AJS.$("#checkBoxResourceFilter").attr('checked', false);

		},
		
		handleRemoveProjects: function(event) {
			var ids = new Array();
		    AJS.$( "#naomi-selected-projects-multiselect option:selected" ).each(function() {
		        ids.push(this.value);
		      });
			this.model.set('selectedProjectIds',ids);
			this.model.set('operation','removeProjects');
			this.model.save();
			AJS.$("#findProjects").val("");
			AJS.$("#checkBoxProjectFilter").attr('checked', false);
			AJS.$("#findResources").val("");
			AJS.$("#checkBoxResourceFilter").attr('checked', false);

		},
		
		handleChangeProjectCheckbox: function(event) {
		    var checked = AJS.$("#checkBoxProjectFilter").prop('checked');
	    	this.model.set('filterByResourcesOption', checked);
	    	this.model.set('operation','toggleFilterByResources');
	    	this.model.save();
		},
		
		handleChangeResourceCheckbox: function(event) {
		    var checked = AJS.$("#checkBoxResourceFilter").prop('checked');
	    	this.model.set('filterByProjectsOption', checked);
	    	this.model.set('operation','toggleFilterByProjects');
	    	this.model.save();
		}
	});
	return AddResourcesButtonView;
});