define('aim/assignment/view/PlanValueView',[
                                            'aim/assignment/view/SelectDistributionView',
                                            'aim/assignment/view/SelectProjectView',
                                            'aim/assignment/view/SelectResourceView',
                                            'aim/assignment/view/SelectFromView',
                                            'aim/assignment/view/SelectToView',
                                            'aim/assignment/view/SelectPlanValueView',
                                            'aim/assignment/view/SelectRestValueView',
                                            'aim/assignment/view/SelectCapacityValueView',
                                            'aim/assignment/view/ExtendFilterView',
                                            'aim/assignment/view/CalendarWeeksView',
                                            'aim/assignment/view/CalendarWeeksWithCapacityView',
                                            'aim/assignment/view/CalendarWeeksWithAvailabilityView',
                                            'aim/assignment/view/DaysWithCapacityView',
                                            'aim/assignment/view/DaysWithAvailabilityView'
                                            ], function(
                                            		SelectDistributionView,
                                            		SelectProjectView,
                                            		SelectResourceView,
                                            		SelectFromView,
                                            		SelectToView,
                                            		SelectPlanValueView,
                                            		SelectRestValueView,
                                            		SelectCapacityValueView,
                                            		ExtendFilterView,
                                            		CalendarWeeksView,
                                            		CalendarWeeksWithCapacityView,
                                            		CalendarWeeksWithAvailabilityView,
                                            		DaysWithCapacityView,
                                            		DaysWithAvailabilityView
                                            ) {
	var PlanValueView = Backbone.View.extend({
		
		el : '#add-plan-value-dialog',
		
		events: {
			"change #product-single-select" : "projectSelectChanged",
			"change #resource-single-select" : "resourceSelectChanged",
			"change #distribution-single-select" : "distributionSelectChanged",
			"change #fromDate" : "fromChanged",
			"change #toDate" : "toChanged",
			"change #planValue" : "planValueChanged",
			"click #planvalues-save-button" : "savePlanValues",
			"click #planvalues-cancel-button" : "cancelPlanValues"
		},
		
		initialize : function() {
			this.listenTo(this.model.get('planValueModel'), 'sync', this.render);
			var selectDistributionView = new SelectDistributionView({model: this.model.get('planValueModel')});
			var selectProjectView = new SelectProjectView({model: this.model.get('planValueModel')});
			var selectResourceView = new SelectResourceView({model: this.model.get('planValueModel')});
			var selectedFromDate = new SelectFromView({model: this.model});
			var selectedToDate = new SelectToView({model: this.model});
			var selectedPlanValueDate = new SelectPlanValueView({model: this.model});
			var selectedRestValueDate = new SelectRestValueView({model: this.model});
			var selectedCapacityValue = new SelectCapacityValueView({model: this.model});
			var extendFilterView = new ExtendFilterView({model: this.model});
			var calendarWeeksView = new CalendarWeeksView({model: this.model});
			var calendarWeeksWithCapacityView = new CalendarWeeksWithCapacityView({model: this.model});
			var calendarWeeksWithAvailabilityView = new CalendarWeeksWithAvailabilityView({model: this.model});
			var daysWithCapacityView = new DaysWithCapacityView({model: this.model});
			var daysWithAvailabilityView = new DaysWithAvailabilityView({model: this.model});
			this.model.get('planValueModel').fetch();
		},
		
		render : function() {
			return this;		
		},
		
		savePlanValues : function() {
			var that = this;
			var planValueModel = this.model.get('planValueModel');
			planValueModel.set('saved', "true");
			planValueModel.set('operation', "spreadInPeriod");
			planValueModel.save(null, {success:function(model, res, options) {
				that.model.get('newFilterModel').fetch();	
				that.model.get('planValueModel').fetch();
				that.model.get('contextModel').fetch();
			}});
			AJS.dialog2("#add-plan-value-dialog").hide();
		},

		cancelPlanValues : function() {
			AJS.dialog2("#add-plan-value-dialog").hide();
			this.model.get('planValueModel').fetch();
		},
		
		distributionSelectChanged : function(event) {
			var value = event.currentTarget.value;
			this.model.get('planValueModel').set('selectedDistribution', value);
		},

		projectSelectChanged : function(event) {
			if(event.added){
				var value = event.added.id;
				if( value != this.model.get('planValueModel').get('selectedProject') ){
					this.model.get('planValueModel').set('selectedResource', 0);
					this.model.get('planValueModel').set('selectedResourceChanged', "true");
				}
				this.model.get('planValueModel').set('selectedProject', value);
				this.model.get('planValueModel').set('selectedProjectChanged', "true");
				this.model.get('planValueModel').save();
			}else if(event.removed){
				var value = 0;
				this.model.get('planValueModel').set('selectedProject', value);
				this.model.get('planValueModel').set('selectedProjectChanged', "true");
				this.model.get('planValueModel').set('selectedResource', 0);
				this.model.get('planValueModel').set('selectedResourceChanged', "true");
				this.model.get('planValueModel').save();
			}
		},

		fromChanged : function(event) {
			var planValueModel = this.model.get('planValueModel');
			event.currentTarget.removeAttribute('data-aui-notification-error');
			var value = event.currentTarget.value;
			planValueModel.set('from', value);
			this.model.get('planValueModel').set('selectedFromChanged', "true");
			planValueModel.save();
		},
		
		toChanged : function(event) {
			var planValueModel = this.model.get('planValueModel');
			event.currentTarget.removeAttribute('data-aui-notification-error');
			var value = event.currentTarget.value;
			planValueModel.set('to', value);
			this.model.get('planValueModel').set('selectedToChanged', "true");
			planValueModel.save();
		},
		
		planValueChanged : function(event) {
			var planValueModel = this.model.get('planValueModel');
			var value = event.currentTarget.value;
			planValueModel.set('planValue', value);
			this.model.get('planValueModel').set('planValueChanged', "true");
			planValueModel.save();
		},
		
		resourceSelectChanged : function(event) {
			if(event.added){
				var value = event.added.id;
				this.model.get('planValueModel').set('selectedResource', value);	
				this.model.get('planValueModel').set('selectedResourceChanged', "true");
				this.model.get('planValueModel').save();
			}else if(event.removed){
				var value = 0;
				this.model.get('planValueModel').set('selectedResource', value);	
				this.model.get('planValueModel').set('selectedResourceChanged', "true");
				this.model.get('planValueModel').save();
			}
		}
	});
	return PlanValueView;
});